"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var check_1 = __importDefault(require("../icon/check"));

var Radio = function (props) {
    var checked = props.checked, disabled = props.disabled, className = props.className, text = props.text, _a = props.type, type = _a === void 0 ? 'primary' : _a, onChange = props.onChange, hollow = props.hollow, _b = props.value, value = _b === void 0 ? '' : _b, otherProps = __rest(props, ["checked", "disabled", "className", "text", "type", "onChange", "hollow", "value"]);
    var composeClassName = classnames_1.default('x-radio', "x-radio--" + type, {
        'x-radio--checked': checked,
        'x-radio--disabled': disabled,
        'x-radio--hollow': hollow,
    }, className);
    var onClick = function () {
        if (disabled) {
            return;
        }
        if (onChange) {
            onChange(!checked, value);
        }
    };
    if (onChange) {
        return (React.createElement("button", __assign({}, otherProps, { className: composeClassName, onClick: onClick }),
            React.createElement("i", { className: "x-radio__icon" },
                React.createElement(check_1.default, null)),
            !!text && React.createElement("span", { className: "x-radio__text" }, text)));
    }
    return (React.createElement("span", __assign({}, otherProps, { className: composeClassName, onClick: onClick }),
        React.createElement("i", { className: "x-radio__icon" },
            React.createElement(check_1.default, null)),
        !!text && React.createElement("span", { className: "x-radio__text" }, text)));
};
exports.default = Radio;
