"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));

var TabsItem = function (props) {
    var active = props.active, value = props.value, className = props.className, onClick = props.onClick, children = props.children, otherProps = __rest(props, ["active", "value", "className", "onClick", "children"]);
    var composeClassName = classnames_1.default('x-tabs__item', {
        'x-tabs--active': !!active,
    }, className);
    var onTabClick = function () {
        onClick(value);
    };
    return (React.createElement("button", __assign({}, otherProps, { className: composeClassName, onClick: onTabClick }),
        React.createElement("span", null, children)));
};
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Tabs.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, children = _a.children, active = _a.active, onClick = _a.onClick, forwardRef = _a.forwardRef, shrink = _a.shrink, otherProps = __rest(_a, ["className", "children", "active", "onClick", "forwardRef", "shrink"]);
        var composeClassName = classnames_1.default('x-tabs', {
            'x-tabs--shrink': shrink,
        }, className);
        var composeChildren = [];
        if (Array.isArray(children)) {
            composeChildren.push.apply(composeChildren, children);
        }
        else {
            composeChildren.push(children);
        }
        composeChildren = composeChildren.map(function (res, index) {
            var act = _this.props.hasOwnProperty('active') && res.props.value === active;
            return React.cloneElement(res, {
                active: act,
                key: index,
                value: res.props.value,
                onClick: _this.props.onClick,
                children: res.props.children,
            });
        });
        if (shrink) {
            return (React.createElement("div", __assign({}, otherProps, { ref: forwardRef, className: composeClassName }),
                React.createElement("div", { className: "x-tabs__scroller" },
                    React.createElement("div", { className: "x-tabs__inner" }, composeChildren))));
        }
        return (React.createElement("div", __assign({}, otherProps, { ref: forwardRef, className: composeClassName }), composeChildren));
    };
    return Tabs;
}(React.PureComponent));
// 转发Ref
var ForwardTabs = (function (Component) {
    return React.forwardRef(function (props, ref) { return (React.createElement(Component, __assign({}, props, { onClick: props.onClick, active: props.active, forwardRef: ref }))); });
})(Tabs);
ForwardTabs.Item = TabsItem;
exports.default = ForwardTabs;
